CON

    Baro_Addr = $A0  'i2c address of baro sensor

OBJ
   i2cObject3      : "ECi2c"

VAR
   byte Baro_Data_f6
   byte Baro_Data_f7
   byte Baro_Data_f8
   byte Baro_Data_f9
   byte Baro_Data_fa
   byte Baro_Data_fb
   byte Baro_Data_fc
   byte Baro_Data_fd
   byte Baro_Data_fe
   byte Baro_Data_ff
  
   long _220uS
   long _40uS
   
   byte i2cSCL, i2cSDA
   
PUB init(_scl, _sda)
   i2cSCL := _scl
   i2cSDA := _sda
   i2cObject3.Init(i2cSDA, i2cSCL)
   _220uS := clkfreq / 100_000 * 22 
   _40uS := clkfreq / 100_000 * 4 

PUB start_adcTemp
   i2cObject3.i2cStart
   i2cObject3.i2cWrite(Baro_Addr)         'write 0xEE to i2c bus
   i2cObject3.i2cWrite($FE)               'write 0xF4 to i2c bus
   i2cObject3.i2cWrite($4)               'write 0xEE sequence to start temp conversion   
   i2cObject3.i2cStop

PUB start_adcPres
   i2cObject3.i2cStart
   i2cObject3.i2cWrite(Baro_Addr)         'write 0xEE to i2c bus
   i2cObject3.i2cWrite($FE)               'write 0xF4 to i2c bus
   i2cObject3.i2cWrite($04 )              'write 0xF4 sequence to start pressure conversion   
   i2cObject3.i2cStop
  
PUB readbaro
   
   i2cObject3.i2cStart
   i2cObject3.i2cWrite(Baro_Addr)         'write 0xEE to i2c bus sensor write address
   i2cObject3.i2cWrite($FB)               'write 0xF6 to i2c bus sensor starting register
   i2cObject3.i2cStart                    'do a restart
   i2cObject3.i2cWrite(Baro_Addr|1)       'write 0xEF (read cmd) to i2c bus sensor read address   

   Baro_Data_f6 := (i2cObject3.i2cRead(0))         'i2c read 12 BYTES with ack bit
   Baro_Data_f7 := (i2cObject3.i2cRead(0))         '           V
   Baro_Data_f8 := (i2cObject3.i2cRead(0))         '           V
   Baro_Data_f9 := (i2cObject3.i2cRead(0))         '           V
   Baro_Data_fa := (i2cObject3.i2cRead(0))         '           V
   Baro_Data_fb := (i2cObject3.i2cRead(0))         '           V
   Baro_Data_fc := (i2cObject3.i2cRead(0))         '           V
   Baro_Data_fd := (i2cObject3.i2cRead(0))         '           V
   Baro_Data_fe := (i2cObject3.i2cRead(0))         '           V
   Baro_Data_ff := (i2cObject3.i2cRead(1))         '           V
    i2cObject3.i2cStop
   

PUB Baro_f6
   return Baro_Data_f6

PUB Baro_f7
   return Baro_Data_f7

PUB Baro_f8
   return Baro_Data_f8

PUB Baro_f9
   return Baro_Data_f9

PUB Baro_fa
   return Baro_Data_fa

PUB Baro_fb
   return Baro_Data_fb

PUB Baro_fc
   return Baro_Data_fc

PUB Baro_fd
   return Baro_Data_fd

PUB Baro_fe
   return Baro_Data_fe

PUB Baro_ff
   return Baro_Data_ff